;; are we running XEmacs or Emacs?
(defvar running-xemacs (string-match "XEmacs\\|Lucid" emacs-version))
;; FIXME
(defun emacs-type-is-regular () t)

;; logging
(defvar log-buffer-name "*initlog*")

(defun log (str)
  "Logs to *initlog*."
  (let ((curbuffer (current-buffer))
        (logbuffer (get-buffer-create log-buffer-name)))
    (switch-to-buffer logbuffer)
    (insert (cond ((stringp str) str)
		    ((not (stringp str)) (join str " "))))
    (insert "\n")
    (switch-to-buffer curbuffer)))

; example:
; (join load-path " ")
(defun join (list delim)
  "Joins a list with a delimiter to a string."
  (let ((str "")
	(newlist list))
    (while newlist
      (setq str (concat str (car newlist)))
      (setq newlist (cdr newlist))
      (if newlist 
	    (setq str (concat str delim))))
    str))


;; Delegate module loading to init-<module-name>.el
(log "loading modules...")
(let 
    ((config-file-list (file-expand-wildcards (expand-file-name "init-*.el" module-path))))
  (dolist (file config-file-list)
    (load file)
    (log file)
    ))
(log "loading modules... done.")

;; Load globals
(load "globals.el")

;; Load keys
(load "keys.el")

;;
;; font-lock-mode
(if (not running-xemacs)
    (global-font-lock-mode t) ; font-lock mode for Emacs
    (font-lock-mode 1)        ; font-lock mode for XEmacs
    )
;;
;; gnuserv (see 'man gnuclient')
(cond (running-xemacs (gnuserv-start)))
