;;; keys.el --- global key definitions

;; Copyright (C) 2003 Georg Martius, Michael Grosse

;; Global key setup for emacs functions and all modes

;;; basic definitions
(global-unset-key "\M-%")
(global-set-key "\M-%"      'query-replace-regexp)
(global-set-key [delete]    'delete-char)
(global-set-key [kp-delete] 'delete-char)
(global-set-key "\C-cl"     'goto-line)


;;; keys for modes and includes

;; buffi: BUild File FInder (for e.g. gnu make, ant)
;; build, build with target
(global-set-key "\C-cc" 'buffi-build)
(global-set-key "\C-cC" 'buffi-build-target)


(cond ((not running-xemacs) (global-set-key [end]  'end-of-line)))
(cond ((not running-xemacs) (global-set-key [home] 'beginning-of-line)))

;; stuff added by Georg (see globals.el)
(global-set-key "\C-t" 'yank-and-forward-line)


;; Compile
(global-set-key [f5] 'compile)

;; next error
(global-set-key [f8] 'next-error)

;; go through buffers
(global-set-key [f7] 'switch-to-next-buffer)

;; all expansion is done by 'my-hippie-expand bound to C-Return
(global-set-key (quote [(control return)]) (quote my-hippie-expand))
(define-key global-map (read-kbd-macro "C-RET") (quote my-hippie-expand))



;; (defun umlaut-tex ()
;;   "make umlaut keys insert ?e"
;;   (interactive)
;;   (local-set-key [196] (lambda () (interactive) (insert "\"A"))) ;A-umlaut
;;   ;;(local-set-key [203] (lambda () (interactive) (insert "\"E"))) ;E-umlaut
;;   (local-set-key [207] (lambda () (interactive) (insert "\"I"))) ;I-umlaut
;;   (local-set-key [214] (lambda () (interactive) (insert "\"O"))) ;O-umlaut
;;   (local-set-key [220] (lambda () (interactive) (insert "\"U"))) ;U-umlaut
;;   (local-set-key [228] (lambda () (interactive) (insert "\"a"))) ;a-umlaut
;;   ;;(local-set-key [235] (lambda () (interactive) (insert "\"e"))) ;e-umlaut
;;   (local-set-key [239] (lambda () (interactive) (insert "\"i"))) ;i-umlaut
;;   (local-set-key [246] (lambda () (interactive) (insert "\"o"))) ;o-umlaut
;;   (local-set-key [252] (lambda () (interactive) (insert "\"u"))) ;u-umlaut
;;   ;;(local-set-key [255] (lambda () (interactive) (insert "\"y"))) ;y-umlaut
;; ;;  (local-set-key [223] (lambda () (interactive) (insert "sz"))) ;sz
;; )
;; (add-hook 'TeX-mode-hook (umlaut-tex))
;; (add-hook 'LaTeX-mode-hook (umlaut-tex))

;; (defun umlaut-html ()
;;   "make umlaut keys insert ?e"
;;   (interactive)
;;   (local-set-key [196] (lambda () (interactive) (insert "&Auml;"))) ;A-umlaut
;;   (local-set-key [203] (lambda () (interactive) (insert "&Euml;"))) ;E-umlaut
;;   (local-set-key [207] (lambda () (interactive) (insert "&Iuml;"))) ;I-umlaut
;;   (local-set-key [214] (lambda () (interactive) (insert "&Ouml;"))) ;O-umlaut
;;   (local-set-key [220] (lambda () (interactive) (insert "&Uuml;"))) ;U-umlaut
;;   (local-set-key [228] (lambda () (interactive) (insert "&auml;"))) ;a-umlaut
;;   (local-set-key [235] (lambda () (interactive) (insert "&euml;"))) ;e-umlaut
;;   (local-set-key [239] (lambda () (interactive) (insert "&iuml;"))) ;i-umlaut
;;   (local-set-key [246] (lambda () (interactive) (insert "&ouml;"))) ;o-umlaut
;;   (local-set-key [252] (lambda () (interactive) (insert "&uuml;"))) ;u-umlaut
;;   (local-set-key [255] (lambda () (interactive) (insert "&yuml;"))) ;y-umlaut
;; ;;  (local-set-key [223] (lambda () (interactive) (insert "&szlig;"))) ;sz
;; )
;; (add-hook 'sgml-mode-hook (umlaut-html))

;; (defun umlaut-text ()
;;   "make umlaut keys insert ?e"
;;   (interactive)
;;   (local-set-key [196] (lambda () (interactive) (insert "Ae"))) ;A-umlaut
;;   (local-set-key [203] (lambda () (interactive) (insert "Ee"))) ;E-umlaut
;;   (local-set-key [207] (lambda () (interactive) (insert "Ie"))) ;I-umlaut
;;   (local-set-key [214] (lambda () (interactive) (insert "Oe"))) ;O-umlaut
;;   (local-set-key [220] (lambda () (interactive) (insert "Ue"))) ;U-umlaut
;;   (local-set-key [228] (lambda () (interactive) (insert "ae"))) ;a-umlaut
;;   (local-set-key [235] (lambda () (interactive) (insert "eu"))) ;e-umlaut
;;   (local-set-key [239] (lambda () (interactive) (insert "ie"))) ;i-umlaut
;;   (local-set-key [246] (lambda () (interactive) (insert "oe"))) ;o-umlaut
;;   (local-set-key [252] (lambda () (interactive) (insert "ue"))) ;u-umlaut
;;   (local-set-key [255] (lambda () (interactive) (insert "ye"))) ;y-umlaut
;; ;;  (local-set-key [223] (lambda () (interactive) (insert "sz"))) ;sz
;; )

;; http://www.dante.de/faq/de-tex-faq/html/tools.html#29